DefInt A-Z
Declare Function GetSystemMetrics% Lib "User" (ByVal nIndex%)

Sub LoadDemoSettings ()
'-- Load settings specific to CTRLDEMO:

    '-- Get the configuration INI filename
    ConfigFile$ = GetConfigFileName$()
    AppName$ = "Application"

    '-- Top and Left properties (position of the form)
    Form1.Top = MWGetConfigInt(AppName$, "Top", Form1.Top, ConfigFile$)
    Form1.Left = MWGetConfigInt(AppName$, "Left", Form1.Left, ConfigFile$)

    '-- Buttons
    AppName$ = "Button Assignments"
    Buffer$ = Space$(256)
    L = MWGetConfigString(AppName$, 0&, "", Buffer$, Len(Buffer$), ConfigFile$)
    Buffer$ = Left$(Buffer$, L)
    Buffer2$ = Space$(256)
    P = 0
    Do
       Tmp$ = Parse$(P, Buffer$, Chr$(0))
       D = InStr(Tmp$, "-")
       If D Then
	  N = Val(Tmp$) - 1
	  Form1.Btn(N).Caption = LTrim$(Mid$(Tmp$, D + 1))
	  L = MWGetConfigString(AppName$, Tmp$, "", Buffer2$, Len(Buffer2$), ConfigFile$)
	  Tmp$ = Left$(Buffer2$, L)
	  D = InStr(Tmp$, "~")
	  If D Then
	     Tmp$ = Left$(Tmp$, D - 1) + Chr$(13) + Chr$(10)
	  End If
	  Form1.Btn(N).Tag = Tmp$
       End If
    Loop While P
   

End Sub

Sub Main ()
'-- This is where CTRLDEMO starts.
    
    '-- Change directories to where the EXE is.
    Path$ = App.Path
    Drive$ = Left$(Path$, 2)
    ChDrive Drive$
    ChDir Path$
    
    '-- Un-Remark this line to use the Windows 3.1 "event notification method".
    '   See the "Technical Help and Tips" document for details about this property.
    'Form1.Comm1.Notification = PDQ_NOTIFICATION_DRIVER
    
    '-- Load CTRLDEMO settings (Window position, buttons, etc.)
    Call LoadDemoSettings

'------------------------------------------------------------
' THIS CODE IS A GOOD EXAMPLE OF HOW TO INITIALIZE YOUR APP
'------------------------------------------------------------
    
    '-- Temporarily disable the form
    Form1.Enabled = False

    '-- Load the terminal settings.
    Call LoadTerminalSettings(Form1.Comm1)

    '-- Size the form
    SizeForm

    '-- Show the screen
    Form1.Show
    Form1.Refresh

    '-- Load the comm port settings
    Call LoadPortSettings(Form1.Comm1)

    '-- Load the modem settings.
    Call LoadModemSettings(Form1.Comm1)
    
    '-- Re-enable the form.
    Form1.Enabled = True

'------------------------------------------------------------
    
    '-- Check the PortOpen menu option to show that the port is open
    Form1.MComm(3).Checked = Form1.Comm1.PortOpen

    '-- Set the caption and focus
    Form1.Caption = "COM" & Trim$(Str$(Form1.Comm1.CommPort)) & ":" & UCase$(Form1.Comm1.Settings)
    Form1.Comm1.SetFocus

End Sub

Function Parse$ (St, Sentence$, Delim$)
'-- This routine parses a string. Used for the buttons

   Ln = Len(Sentence$)

   If St < 1 Then St = 1
   P = InStr(St, Sentence$, Delim$)
   If P = 0 Then P = Ln + 1

   Parse$ = LTrim$(Mid$(Sentence$, St, P - St))
   St = P + 1
   
   If St > Ln Then St = 0
 
End Function

Sub ReplaceChar (Source$, OldStr$, NewStr$)
'-- Replaces all occurrences of a string within a string
    
    Do
	CurPos = InStr(Source$, OldStr$)
	If CurPos Then
	    Source$ = Left$(Source$, CurPos - 1) + NewStr$ + Mid$(Source$, CurPos + Len(OldStr$))
	Else
	    Exit Do
	End If
    Loop

End Sub

Sub SaveDemoSettings ()
'-- Save settings specific to CTRLDEMO:

    '-- Get the configuration INI filename
    ConfigFile$ = GetConfigFileName$()
    AppName$ = "Application"

    '-- Top and Left properties (position of the form)
    Dummy = MWPutConfigString(AppName$, "Top", Str$(Form1.Top), ConfigFile$)
    Dummy = MWPutConfigString(AppName$, "Left", Str$(Form1.Left), ConfigFile$)

    '-- Buttons
    For N = 0 To 9
       If Len(Form1.Btn(N).Tag) Then
	  Tmp$ = Form1.Btn(N).Tag
	  C = InStr(Tmp$, Chr$(13) + Chr$(10))
	  If C Then
	     Tmp$ = Left$(Tmp$, C - 1) + "~"
	  End If
	  X = MWPutConfigString("Button Assignments", LTrim$(Str$(N + 1)) + " - " + Form1.Btn(N).Caption, Tmp$, ConfigFile$)
       End If
    Next
    
End Sub

Sub SizeForm ()

    '-- Size the form
    'X% = GetSystemMetrics%(17)
    X% = Screen.Height
    Form1.Comm1.AutoSize = True
    Form1.Width = Form1.Comm1.Width + (Form1.Width - Form1.ScaleWidth)
    Height% = Form1.Comm1.Height + Form1.Comm1.Top + (Form1.Height - Form1.ScaleHeight) + Form1.Status.Height + Form1.BBar.Height
'    Height% = Form1.Comm1.Height + Form1.Comm1.Top + Form1.Status.Height + 2 * Form1.BBar.Height
    If Height% > X% Then
	Form1.Comm1.AutoSize = False
	Form1.Comm1.Height = X% - (Form1.Status.Height + Form1.BBar.Height + (Form1.Height - Form1.ScaleHeight))
	Height% = Form1.Comm1.Height + Form1.Comm1.Top + (Form1.Height - Form1.ScaleHeight) + Form1.Status.Height + Form1.BBar.Height
    End If
    Form1.Height = Height%
    
    W = Form1.BBar.Width \ 5
    For R = 0 To 5 Step 5
       T = Form1.Btn(R).Top
       For B = 0 To 4
	  L = B * W
	  Form1.Btn(R + B).Move L, T, W
       Next
    Next

End Sub

Sub StatusPrint (Msg$)
'-- This routine prints a message in the status box
'   at the bottom of the form.
    
    Static Last$
    Form1.Status.Cls
    
    '-- Draw a 3-D border around the status bar
    Margin = 3
    White& = &HFFFFFF
    Gray& = &H808080
    Form1.Status.ForeColor = White&
    Form1.Status.Line (Form1.Status.ScaleWidth - Margin, Margin)-(Form1.Status.ScaleWidth - Margin, Form1.Status.ScaleHeight - Margin)
    Form1.Status.Line (Form1.Status.ScaleWidth - Margin, Form1.Status.ScaleHeight - Margin)-(Margin, Form1.Status.ScaleHeight - Margin)
    Form1.Status.ForeColor = Gray&
    Form1.Status.Line (Margin, Margin)-(Form1.Status.ScaleWidth - Margin, Margin)
    Form1.Status.Line (Margin, Form1.Status.ScaleHeight - Margin)-(Margin, Margin)
    Form1.Status.ForeColor = 0&
    
    If Len(Msg$) = 0 Then
	Form1.Status.Print " " + Last$
    Else
	Form1.Status.Print " " + Msg$
    End If
    
    Last$ = Msg$
    
End Sub

