Option Explicit

'-- ModemWare Copyright (c) 1992 - 1994 Crescent Software.
'   Written by Carl Franklin with help from and thanks to Bill Conley.

Sub CaptureStart (Comm1 As Control, Mode)
'-- This routine opens a capture file. A capture file is a session log
'   that contains everything displayed on the screen.

Dim FileName$, CMode$

    FileName$ = GetFileName$("Text Files|*.TXT|All Files|*.*||", "TXT", "*.TXT", "Capture Filename", 0)
    If Len(FileName$) = 0 Then Exit Sub
    Comm1.CaptureMode = Mode
    Comm1.CaptureFilename = FileName$
    MW_Capturing = True
    
    Select Case Mode
        Case PDQ_CAPTURE_BINARY
            CMode$ = "BINARY"
        Case PDQ_CAPTURE_VISIBLE
            CMode$ = "VISIBLE"
        Case PDQ_CAPTURE_STANDARD
            CMode$ = "STANDARD"
    End Select

    StatusPrint "Capturing [" & CMode$ & "] to " & FileName$

    '-- Are we recording a script?
    If MW_ScriptRecording Then
        AddToRecScriptData "CAPTURE", FileName$
    End If

End Sub

Sub CaptureStop (Comm1 As Control)
'-- Closes the capture file.

    Comm1.CaptureFilename = ""
    StatusPrint "Capture File Closed"
    MW_Capturing = False
    
    '-- Are we recording a script?
    If MW_ScriptRecording Then
        AddToRecScriptData "CLOSECAPTURE", ""
    End If

End Sub

