Option Explicit

'-- ModemWare Copyright (c) 1992 - 1994 Crescent Software.
'   Written by Carl Franklin with help from and thanks to Bill Conley.

Sub SetPortSettings (Comm1 As Control)
'-- This routine uses the ConfigScrn port configuration dialog
'   to set up a particular comm control. All settings are saved to
'   an INI file of the same name as the application

Dim Comma As Integer, I As Integer, Dummy As Integer, OldRoutine
Dim Settings$, Baud$, Parity$, DataBits$, StopBits$, Temp$, ConfigFile$, AppName$
'-- This code sets up the config dialog with the current port settings

    OldRoutine = MW_CurRoutine
    MW_CurRoutine = MW_PROC_SETPORTSETTINGS
    Set MW_Global_Comm1 = Comm1

    '-- Hourglass
    Screen.MousePointer = 11
    
    '-- Caption
    MWPort.Caption = Comm1.Tag & " Setup"
    
    '-- Echo
    If Comm1.Echo Then MWPort.Echo(1).Value = True
    
    '-- Port
    MWPort.Port(Comm1.CommPort).Value = True
    
    '-- Parse the Settings property
    Settings$ = Comm1.Settings
    Comma = InStr(Settings$, ",")
    Baud$ = Left$(Settings$, Comma - 1)
    Parity$ = Mid$(Settings$, Comma + 1, 1)
    DataBits$ = Mid$(Settings$, Comma + 3, 1)
    StopBits$ = Mid$(Settings$, Comma + 5, 1)
    
    '-- Baud
    For I = 1 To 10
        If InStr(Baud$, MWPort.Baud(I).Caption) Then
            MWPort.Baud(I).Value = True
            Exit For
        End If
    Next

    '-- Parity
    For I = 1 To 3
        Temp$ = MWPort.Parity(I).Tag
        If UCase$(Parity$) = Temp$ Then
            MWPort.Parity(I).Value = True
            Exit For
        End If
    Next

    '-- DataBits
    If DataBits$ = "7" Then
        MWPort.DataBits(1).Value = True
    Else
        MWPort.DataBits(2).Value = True
    End If

    '-- StopBits
    MWPort.StopBits(Val(StopBits$)).Value = True

    '-- Handshaking
    MWPort.Flow(Comm1.Handshaking).Value = True
    
    '-- DTR
    If Comm1.DTREnable Then
        MWPort.DTR(1).Value = True
    Else
        MWPort.DTR(0).Value = True
    End If
    
    '-- RTS
    If Comm1.RTSEnable Then
        MWPort.RTS(1).Value = True
    Else
        MWPort.RTS(0).Value = True
    End If
    
    '-- Normal cursor
    Screen.MousePointer = 0

'-- Show the setup dialog modally.

    MWPort.Show 1

    If MWPort.Tag = "" Then
        '-- ConfigScrn sets it's Tag property to "" if Cancel was pressed.
        MW_CurRoutine = OldRoutine
        Exit Sub
    End If

'-- Save the information

    '-- Get the configuration INI filename
    ConfigFile$ = GetConfigFileName$()
    
    '-- Set InputLen and Interval properties
    Comm1.InputLen = 0
    Comm1.Interval = 55

    '-- All Comm Port Settings are listed under "[Port]" in the INI file.
    AppName$ = "Port_" & Comm1.Tag
    
    '-- Save Port Number
    Dummy = MWPutConfigString(AppName$, "Comm Port", Str$(MW_Global_Comm1.CommPort), ConfigFile$)
    '-- Save Settings (Baud rate, Parity, Data bits, StopBits)
    Dummy = MWPutConfigString(AppName$, "Settings", MW_Global_Comm1.Settings, ConfigFile$)
    '-- Save DTR
    Dummy = MWPutConfigString(AppName$, "DTREnable", Str$(MW_Global_Comm1.DTREnable), ConfigFile$)
    '-- Save RTS
    Dummy = MWPutConfigString(AppName$, "RTSEnable", Str$(MW_Global_Comm1.RTSEnable), ConfigFile$)
    '-- Save Handshaking
    Dummy = MWPutConfigString(AppName$, "Handshaking", Str$(MW_Global_Comm1.Handshaking), ConfigFile$)
    '-- Save Echo
    Dummy = MWPutConfigString(AppName$, "Echo(Duplex)", Str$(MW_Global_Comm1.Echo), ConfigFile$)

    '-- Are we recording a script?
    If MW_ScriptRecording Then
        AddToRecScriptData "PORT", Str$(Comm1.CommPort)
        Settings$ = Comm1.Settings
        AddToRecScriptData "SETTINGS", Settings$
    End If
    MW_CurRoutine = OldRoutine
    
End Sub

Sub LoadPortSettings (Comm1 As Control)

Dim Test As Integer, WasOpen As Integer, Dummy As Integer, OldRoutine As Integer
Dim ConfigFile$, AppName$, Temp$

    OldRoutine = MW_CurRoutine
    MW_CurRoutine = MW_PROC_LOADPORTSETTINGS
    If MW_Init = 0 Then Call InitModemWare

    '-- Test Comm port validity
    On Error Resume Next
    Test = Comm1.PortOpen
    If Err Then
        '-- Port can not be accessed
        MWSetError MW_ER_CTRLERROR
        Exit Sub
    End If
    On Error GoTo 0
    
    '-- Close the port if it's open
    If Comm1.PortOpen Then
        WasOpen = True
        Comm1.PortOpen = False
    End If
    
    '-- Get the configuration INI filename
    ConfigFile$ = GetConfigFileName$()
    
    '-- Comm Port Settings are listed under "[Port_'TagProperty']" in the INI file.
    AppName$ = "Port_" & Comm1.Tag
    
    '-- Save Port Number
    Temp$ = Space$(4)
    Dummy = MWGetConfigString(AppName$, "Comm Port", "", Temp$, 4, ConfigFile$)
    If Dummy = 0 Then GoTo SetPort
    Comm1.CommPort = Val(Temp$)
    
    '-- Get Settings (Baud rate, Parity, Data bits, StopBits)
    Temp$ = Space$(20)
    Dummy = MWGetConfigString(AppName$, "Settings", "", Temp$, 20, ConfigFile$)
    If Dummy = 0 Then GoTo SetPort
    Comm1.Settings = Trim$(Temp$)
    
    '-- Get DTR
    Temp$ = Space$(3)
    Dummy = MWGetConfigString(AppName$, "DTREnable", "", Temp$, 3, ConfigFile$)
    If Dummy = 0 Then GoTo SetPort
    Comm1.DTREnable = Val(Trim$(Temp$))
    
    '-- Get RTS
    Temp$ = Space$(3)
    Dummy = MWGetConfigString(AppName$, "RTSEnable", "", Temp$, 3, ConfigFile$)
    If Dummy = 0 Then GoTo SetPort
    Comm1.RTSEnable = Val(Trim$(Temp$))

    '-- Get Handshaking
    Temp$ = Space$(3)
    Dummy = MWGetConfigString(AppName$, "Handshaking", "", Temp$, 3, ConfigFile$)
    If Dummy = 0 Then GoTo SetPort
    Comm1.Handshaking = Val(Trim$(Temp$))
    
    '-- Get Echo
    Temp$ = Space$(3)
    Dummy = MWGetConfigString(AppName$, "Echo(Duplex)", "", Temp$, 3, ConfigFile$)
    If Dummy = 0 Then GoTo SetPort
    Comm1.Echo = Val(Trim$(Temp$))
    
    If WasOpen Then
        On Error GoTo SetPort
        Comm1.PortOpen = True
    End If
    
    MW_CurRoutine = OldRoutine
    Exit Sub

SetPort:
    
    MW_SetupFlag = True
    Call SetPortSettings(Comm1)
    MW_SetupFlag = False
    MW_CurRoutine = OldRoutine
    Exit Sub

End Sub

