Option Explicit

'-- ModemWare Copyright (c) 1992 - 1994 Crescent Software.
'   Written by Carl Franklin with help from and thanks to Bill Conley.

Sub LoadTerminalSettings (Comm1 As Control)

Dim Test As Integer, I As Integer, C As Integer, S As Integer, T As Integer
Dim Dummy As Integer, L As Integer
Dim ConfigFile$, AppName$, Buffer$, Txt$, Temp!

    '-- Test Comm port validity
    On Error Resume Next
    Test = Comm1.PortOpen
    If Err Then
        '-- Port can not be accessed
        MWSetError MW_ER_CTRLERROR
        Exit Sub
    End If
    On Error GoTo 0
    
    '-- Is the modem is currently connected.
    If Comm1.CDHolding Then
        MWSetError MW_INITMODEM_ONLINE
        Exit Sub
    End If

    '-- InitModemWare initializes MW_CR$, MW_LF$, etc.
    Call InitModemWare
    
    '-- Initialize the font name
    For I = 1 To Screen.FontCount
        If Screen.Fonts(I) = "Courier" Then
            C = True
        ElseIf Screen.Fonts(I) = "System" Then
            S = True
        ElseIf Screen.Fonts(I) = "Terminal" Then
            T = True
        End If
    Next
    If C Then Comm1.FontName = "Courier"
    If S Then Comm1.FontName = "System"
    If T Then Comm1.FontName = "Terminal"
        
'************************************************************************
    '-- These are ModemWare's default terminal settings.

    Comm1.Rows = 25
    Comm1.Columns = 80
    Comm1.ScrollRows = 409
    Comm1.AutoSize = True
    Comm1.AutoScroll = PDQ_AUTOSCROLL_VERTKEY
    Comm1.XferProtocol = PDQ_ZMODEM
    Comm1.RThreshold = 0
    Comm1.AutoProcess = PDQ_AUTOPROCESS_BOTH
    
    MW_DisplayFlag = True

'************************************************************************

    '-- Get the configuration INI filename
    ConfigFile$ = GetConfigFileName$()
    AppName$ = "Terminal_" & Comm1.Tag
    
    '-- Emulation
    Dummy = MWGetConfigInt(AppName$, "Emulation", 0, ConfigFile$)
    If Dummy Then
        Comm1.Emulation = Dummy
    Else
        Comm1.Emulation = PDQ_EMULATION_ANSI
        Call SetTerminalSettings(Comm1)
        Exit Sub
    End If
    
    '-- FontName
    Buffer$ = Space$(30)
    L = MWGetConfigString(AppName$, "FontName", Comm1.FontName, Buffer$, Len(Buffer$), ConfigFile$)
    On Error Resume Next
    Comm1.FontName = Left$(Buffer$, L)
    On Error GoTo 0
    DoEvents
    
    '-- FontSize
    Buffer$ = Space$(4)
    L = MWGetConfigString(AppName$, "FontSize", "9.1", Buffer$, Len(Buffer$), ConfigFile$)
    DoEvents
    Temp! = Val(Left$(Buffer$, L))
    Comm1.FontSize = Temp! + 1
    
    '-- FontBold
    Comm1.FontBold = MWGetConfigInt(AppName$, "FontBold", 0, ConfigFile$) + .1
    
    '-- BackColor, ForeColor
    Comm1.BackColor = MWGetConfigInt(AppName$, "BackColor", 1, ConfigFile$)
    Comm1.ForeColor = MWGetConfigInt(AppName$, "ForeColor", 15, ConfigFile$)
    
    '-- ScrollRows
    Comm1.ScrollRows = MWGetConfigInt(AppName$, "ScrollRows", 409, ConfigFile$)

    '-- Reset the contents of the screen
    Txt$ = Comm1.Text
    Comm1.Text = ""
    Do
        If Right$(Txt$, 2) = MW_CR$ + MW_LF$ Then
            Txt$ = Left$(Txt$, Len(Txt$) - 2)
        Else
            Txt$ = Txt$ + MW_CR$ + MW_LF$
            Comm1.Disp = Txt$
            Exit Do
        End If
    Loop


End Sub

Sub SetTerminalSettings (Comm1 As Control)
    
Dim Dummy As Integer
Dim ConfigFile$, AppName$

    Set MW_Global_Comm1 = Comm1
    
    '-- Set The Caption
    MWTerm.Caption = Comm1.Tag & " Terminal Settings"
    
    '-- Show the Terminal setup form modally.
    MWTerm.Show 1
    
    If MWTerm.Tag = "" Then
        '-- MWTermSet sets it's Tag property to "" if Cancel was pressed.
        Exit Sub
    End If

    '-- Get the configuration INI filename
    ConfigFile$ = GetConfigFileName$()
    AppName$ = "Terminal_" & Comm1.Tag
    
    '-- Emulation
    Dummy = MWPutConfigString(AppName$, "Emulation", Str$(MW_Global_Comm1.Emulation), ConfigFile$)
    '-- FontName
    Dummy = MWPutConfigString(AppName$, "FontName", MW_Global_Comm1.FontName, ConfigFile$)
    '-- FontSize
    Dummy = MWPutConfigString(AppName$, "FontSize", Str$(MW_Global_Comm1.FontSize), ConfigFile$)
    '-- FontBold
    Dummy = MWPutConfigString(AppName$, "FontBold", Str$(MW_Global_Comm1.FontBold), ConfigFile$)
    '-- BackColor, ForeColor
    Dummy = MWPutConfigString(AppName$, "BackColor", Str$(MW_Global_Comm1.BackColor), ConfigFile$)
    Dummy = MWPutConfigString(AppName$, "ForeColor", Str$(MW_Global_Comm1.ForeColor), ConfigFile$)
    '-- ScrollRows
    Dummy = MWPutConfigString(AppName$, "ScrollRows", Str$(MW_Global_Comm1.ScrollRows), ConfigFile$)

End Sub

