Option Explicit

'-- ModemWare Copyright (c) 1992 - 1994 Crescent Software.
'   Written by Carl Franklin with help from and thanks to Bill Conley.

Sub Download (Comm1 As Control)
'-- This routine asks for a filename and initiates a download (receive file)

Dim Protocol As Integer
Dim T$, FileName$, Prot$

    Set MW_Global_Comm1 = Comm1
    
    MWProtocol.Show 1
    T$ = MWProtocol.Tag
    
    If Len(T$) = 0 Then
        Exit Sub
    ElseIf T$ = "X" Then
        Protocol = Comm1.XferProtocol
    Else
        MsgBox "To download an ASCII file, turn capture on"
        Exit Sub
    End If

    '-- If we're using a batch protocol, the filename is ""
    Select Case Protocol
        Case PDQ_YMODEM_BATCH, PDQ_YMODEM_G, PDQ_ZMODEM, PDQ_COMPUSERVE_BPLUS, PDQ_KERMIT
            FileName$ = ""
        Case Else
            FileName$ = GetFileName$("All Files|*.*||", "*", "*.*", "Download File", 0)
            If Len(FileName$) = 0 Then Exit Sub
    End Select
    
    '-- Are we recording a script?
    If MW_ScriptRecording Then
        Select Case Protocol
            Case PDQ_XMODEM_CHECKSUM
                Prot$ = "XMODEM-CHECKSUM"
            Case PDQ_XMODEM_CRC
                Prot$ = "XMODEM-CRC"
            Case PDQ_XMODEM_1K
                Prot$ = "XMODEM-1K"
            Case PDQ_YMODEM_BATCH
                Prot$ = "YMODEM-BATCH"
            Case PDQ_YMODEM_G
                Prot$ = "YMODEM-G"
            Case PDQ_ZMODEM
                Prot$ = "ZMODEM"
            Case PDQ_COMPUSERVE_BPLUS
                Prot$ = "COMPUSERVE"
            Case PDQ_KERMIT
                Prot$ = "KERMIT"
        End Select
        AddToRecScriptData "PROTOCOL", Prot$
        AddToRecScriptData "DOWNLOAD", UCase$(FileName$)
    End If
    
    '-- Display Modeless dialog box (allows background transfer)
    'Comm1.XferStatusDialog = PDQ_XFERDIALOG_MODAL
    Comm1.XferStatusDialog = PDQ_XFERDIALOG_MODELESS
    
    '-- Start the download
    Comm1.Download = FileName$
    
End Sub

Function GetFileName$ (Extensions$, DefaultExt$, DefaultFile$, Caption$, Flags%)
'-- This routine opens the PDQCOMM file dialog box and returns a file name.

    MWProtocol.FileDialog1.Filter = Extensions$
    MWProtocol.FileDialog1.DefaultExt = DefaultExt$
    MWProtocol.FileDialog1.FileName = DefaultFile$
    MWProtocol.FileDialog1.DlgTitle = Caption$
    MWProtocol.FileDialog1.Flags = Flags%
    
    On Error Resume Next
    MWProtocol.FileDialog1.Action = 1
    If Err Then Exit Function

    GetFileName$ = MWProtocol.FileDialog1.FileName
    MW_Global_Comm1.SetFocus

End Function

Function MWSetProtocol (Comm1 As Control)
'-- Sets the file transfer protocol, and returns true if
'   the protocol is ASCII

Dim Index As Integer
Dim Prot$
    
    Set MW_Global_Comm1 = Comm1
    Index = MW_Global_Comm1.XferProtocol
    
    If Index <> 8 Then '-- 8 = ASCII (Non binary)
        MWProtocol.Option1(Index).Value = True
        MWProtocol.Show 1
    Else
        MWSetProtocol = True
    End If
    
    If MW_ScriptRecording Then
        Select Case Comm1.XferProtocol
            Case PDQ_XMODEM_CHECKSUM
                Prot$ = "XMODEM-CHECKSUM"
            Case PDQ_XMODEM_CRC
                Prot$ = "XMODEM-CRC"
            Case PDQ_XMODEM_1K
                Prot$ = "XMODEM-1K"
            Case PDQ_YMODEM_BATCH
                Prot$ = "YMODEM-BATCH"
            Case PDQ_YMODEM_G
                Prot$ = "YMODEM-G"
            Case PDQ_ZMODEM
                Prot$ = "ZMODEM"
            Case PDQ_COMPUSERVE_BPLUS
                Prot$ = "COMPUSERVE"
            Case PDQ_KERMIT
                Prot$ = "KERMIT"
        End Select
        AddToRecScriptData "PROTOCOL", Prot$
    End If
    
End Function

Sub Upload (Comm1 As Control)
'-- This routine gets a filename (if applicable) and uploads it (send)

Dim Protocol As Integer, Flags As Integer, Spac As Integer, ErrCode As Integer
Dim T$, DefaultExt$, Extensions$, DefaultFile$, FileName$, Prot$, File$, Msg$, FPath$

    Set MW_Global_Comm1 = Comm1
    
    MWProtocol.Show 1
    T$ = MWProtocol.Tag

    If Len(T$) = 0 Then
        Exit Sub
    ElseIf T$ = "X" Then
        Protocol = Comm1.XferProtocol
    Else
        Protocol = 0
    End If
    
    Comm1.XferStatusDialog = PDQ_XFERDIALOG_MODELESS
    
    '-- Get a file name
    If Protocol <> PDQ_COMPUSERVE_BPLUS Then
        DefaultExt$ = "ZIP"
        Extensions$ = "PKWare Zip Files|*.ZIP|All Files|*.*||"
        DefaultFile$ = "*.ZIP"
        If Protocol >= 3 And Protocol <= 6 Then
            Flags = &H200 Or &H1000
        Else
            Flags = &H1000
        End If
        FileName$ = GetFileName$(Extensions$, DefaultExt$, DefaultFile$, "Send File", Flags)
        If Len(FileName$) = 0 Then Exit Sub
    End If

    '-- Are we recording a script?
    If MW_ScriptRecording Then
        Select Case Protocol
            Case 0
                GoTo MWStartUpload:
            Case PDQ_XMODEM_CHECKSUM
                Prot$ = "XMODEM-CHECKSUM"
            Case PDQ_XMODEM_CRC
                Prot$ = "XMODEM-CRC"
            Case PDQ_XMODEM_1K
                Prot$ = "XMODEM-1K"
            Case PDQ_YMODEM_BATCH
                Prot$ = "YMODEM-BATCH"
            Case PDQ_YMODEM_G
                Prot$ = "YMODEM-G"
            Case PDQ_ZMODEM
                Prot$ = "ZMODEM"
            Case PDQ_COMPUSERVE_BPLUS
                Prot$ = "COMPUSERVE"
            Case PDQ_KERMIT
                Prot$ = "KERMIT"
        End Select
        AddToRecScriptData "PROTOCOL", Prot$
    End If
    
    FPath$ = ""
    Spac = InStr(FileName$, " ")
    Do While Spac
        If Len(FPath$) Then
            File$ = Left$(FileName$, Spac - 1)
            FileName$ = Mid$(FileName$, Spac + 1)
            If MW_ScriptRecording Then AddToRecScriptData "UPLOAD", UCase$(FPath$) & UCase$(File$)
            Comm1.Upload = UCase$(FPath$) & File$
            Debug.Print "Uploading "; FPath$ & File$
        Else
            FPath$ = Left$(FileName$, Spac - 1) & "\"
            FileName$ = Mid$(FileName$, Spac + 1)
        End If
        Spac = InStr(FileName$, " ")
    Loop
    If MW_ScriptRecording Then AddToRecScriptData "UPLOAD", UCase$(FileName$)
    Comm1.Upload = FPath$ & FileName$
    Debug.Print "Uploading "; FPath$ & FileName$

MWStartUpload:

    '-- Upload
    If Protocol = 0 Then    '-- ASCII
        Call MWStatus(0, "Sending ASCII File")
        Call AsciiSend(Comm1, FileName$, ErrCode)
        Select Case ErrCode
            '-- Operation was canceled, Carrier was lost, port does not exist or cannot be accessed
            Case MW_ER_CANCELED, MW_ER_LOST_CARRIER, MW_ER_PORTCLOSED, MW_ER_CTRLERROR
                Msg$ = MWErrorMsg$()
            Case MW_ASCIISEND_NOTFOUND  '-- File not found.
                Msg$ = "File Not Found"
            Case MW_ASCIISEND_FILE_ERR  '-- Error reading file.
                Msg$ = "Error Reading " & FileName$
            Case MW_ASCIISEND_OK        '-- File sent ok.
                Msg$ = "File Transferred Successfully"
        End Select
        Call MWStatus(0, Msg$)
    Else
        'Comm1.XferStatusDialog = PDQ_XFERDIALOG_MODAL
        'Comm1.Upload = FileName$
    End If
    Exit Sub

End Sub

Sub AsciiSend (Comm1 As Control, FileName$, CDFlag)
'-- This routine sends a file via the ASCII protocol

Dim Handle As Integer, AutoP As Integer, RT As Integer
Dim NextLine$

    '-- Test Comm port validity
    On Error Resume Next
    If Comm1.PortOpen = False Then
        '-- Port it closed
        MWSetError MW_ER_PORTCLOSED
        Exit Sub
    End If
    If Err Then
        '-- Port can not be accessed
        MWSetError MW_ER_CTRLERROR
        Exit Sub
    End If
    
    '-- InitModemWare initializes MW_CR$, MW_LF$, etc.
    Call InitModemWare
    
    '-- Initialize return variables
    MWSetError 0
    
    '-- Open the file and count the number of lines.
    Handle = FreeFile
    Open FileName$ For Input As Handle
    If Err Then
        MWSetError MW_ASCIISEND_NOTFOUND
        Exit Sub
    End If
    
    '-- Tell everyone where we are.
    If Not MW_CurRoutine Then
        MW_CurRoutine = MW_PROC_ASCIISEND
    End If
    
    '-- Turn Off AutoProcess & RThreshold
    AutoP = Comm1.AutoProcess
    If AutoP Then
        Comm1.AutoProcess = PDQ_AUTOPROCESS_NONE
    End If
    RT = Comm1.RThreshold
    If RT Then
        Comm1.RThreshold = 0
    End If

    '-- Are we recording a script?
    If MW_ScriptRecording Then
        AddToRecScriptData "PROTOCOL", "ASCII"
        AddToRecScriptData "UPLOAD", UCase$(FileName$)
    End If
          
    '-- Here we go...
    Do
        '-- Check Carrier
        If CDFlag Then
            If Comm1.CDHolding = False Then
                MWSetError MW_ER_LOST_CARRIER
                Exit Do
            End If
        End If
        
        '-- Have we been Canceled?
        If MW_CancelFlag Then
            MW_CancelFlag = False
            MWSetError MW_ER_CANCELED
            MWStatus 0, "Ascii Send Aborted"
            Exit Do
        End If

        '-- Get the next line
        Line Input #Handle, NextLine$
        
        '-- Possibly end of file?
        If Len(NextLine$) = 0 Then
            If EOF(Handle) Then
                MWSetError MW_ASCIISEND_OK
                Exit Do
            End If
        End If

        '-- File Error?
        If Err Then
            MWSetError MW_ER_FILE_ERR
            Exit Do
        End If
        
        '-- Send it out the comm port
        Comm1.Output = NextLine$ & MW_CRLF$
        
        '-- Wait until the transmit buffer is empty
        Do
            DoEvents
        Loop Until Comm1.OutBufferCount = 0
        
        '-- Process the next line
        If EOF(Handle) Then
            MWSetError MW_ASCIISEND_OK
            Exit Do
        End If
    
    Loop
    
    '-- Close the file, and we're done
    Close Handle
    
ASExit:

    '-- Reset AutoProcess and RThreshold
    If AutoP Then
        Comm1.AutoProcess = AutoP
    End If
    If RT Then
        Comm1.RThreshold = RT
    End If

    '-- We're outta here
    MW_CurRoutine = MW_PROC_NONE

End Sub

